Bug 955478 - Unresolved dependencies silently ignored
Summary: Unresolved dependencies silently ignored
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: mock
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Clark Williams
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-04-23 06:28 UTC by Max Romanov
Modified: 2014-06-16 11:33 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2013-11-10 06:36:59 UTC
max.romanov: needinfo+


Attachments (Terms of Use)
Patch to check missing dependencies in yum output (1.16 KB, patch)
2013-04-23 06:28 UTC, Max Romanov
no flags Details | Diff
Don't silently ignore missing dependencies (1.18 KB, patch)
2013-10-23 19:43 UTC, Clark Williams
no flags Details | Diff

Description Max Romanov 2013-04-23 06:28:04 UTC
Created attachment 738830 [details]
Patch to check missing dependencies in yum output

Description of problem:
My repository wrongly have a mix of i386 and x86_64 packages. Unfortunately there were no perl.i386, but was net-snmp.i386, which requires libperl.so. Once I've tried to build the package, which requires net-snmp-devel for build, mock does not install any requirements and (silently) goes to rpmbuild -bb which of course fails.

Version-Release number of selected component (if applicable):
I'm using epel version for CentOS 5 (1.0.37), but as far as I inspect the sources, I've found the same defect in latest 1.1.32.
yum-3.2.22-40

How reproducible:
Build a package on a repo with missing dependencies

Steps to Reproduce:
1. build 'a' package with following spec and put it to repo
Name:    a
Version: 1.0
Release: 0
Summary: a
License: Commercial
Group:   System Environment/Daemons

BuildRoot: %{_tmppath}/%{name}-buildroot
BuildArch: noarch

Requires: liba.so # definitely missing symbol

%description
a

%prep

%build

%install

%files
%defattr(-, root, root)

%changelog
2. try to build 'b' package with following spec
Name:    b
Version: 1.0
Release: 0
Summary: b
License: Commercial
Group:   System Environment/Daemons

BuildRoot: %{_tmppath}/%{name}-buildroot
BuildArch: noarch

BuildRequires: a

%description
b

%prep

%build

%install

%files
%defattr(-, root, root)

%changelog
  
Actual results:
Package b successfully built.

Expected results:
Error installing required package 'a' because of missing dependencies.

Additional info:

Comment 1 Clark Williams 2013-04-30 19:06:16 UTC
I'll try and apply/test your patch later this week. Thanks!

Comment 2 Fedora End Of Life 2013-09-16 16:39:57 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 20 development cycle.
Changing version to '20'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora20

Comment 3 Clark Williams 2013-10-23 19:39:56 UTC
Ok, took a little longer to get to than I thought it would. 

The try/except addition in your patch confused me for a bit, since it looked like all you were doing was translating a YumError exception into a BuildError exception. I finally spotted the check for "Missing dependency" and saw what was going on. 

What do you think about just adding the 'or' clause to the existing check without the new try/except block?

I'll attach my modification to your patch. 

I'll need to run this through the test suite and possibly think about it some more since this is a change in default behavior and modifying it could potentially break someone else depending on it (even though it's wrong).

Comment 4 Clark Williams 2013-10-23 19:43:47 UTC
Created attachment 815532 [details]
Don't silently ignore missing dependencies

Patch to check yum output for missing dependencies

Comment 5 Fedora Update System 2013-10-30 14:58:04 UTC
mock-1.1.34-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mock-1.1.34-1.fc18

Comment 6 Fedora Update System 2013-10-30 14:59:46 UTC
mock-1.1.34-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.34-1.el6

Comment 7 Fedora Update System 2013-10-30 15:02:16 UTC
mock-1.1.34-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.34-1.fc20

Comment 8 Fedora Update System 2013-10-30 15:04:20 UTC
mock-1.1.34-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.34-1.fc19

Comment 9 Fedora Update System 2013-10-30 17:12:20 UTC
Package mock-1.1.34-1.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing mock-1.1.34-1.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-20329/mock-1.1.34-1.fc20
then log in and leave karma (feedback).

Comment 10 Fedora Update System 2013-11-05 05:32:21 UTC
mock-1.1.35-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.35-1.fc19

Comment 11 Fedora Update System 2013-11-05 05:34:10 UTC
mock-1.1.35-1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mock-1.1.35-1.fc18

Comment 12 Fedora Update System 2013-11-05 05:35:30 UTC
mock-1.1.35-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.35-1.el6

Comment 13 Fedora Update System 2013-11-05 05:36:48 UTC
mock-1.1.35-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.35-1.fc20

Comment 14 Fedora Update System 2013-11-10 06:36:59 UTC
mock-1.1.35-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 15 Fedora Update System 2014-02-06 02:09:36 UTC
mock-1.1.36-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.36-1.fc19

Comment 16 Fedora Update System 2014-02-06 02:11:19 UTC
mock-1.1.36-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.36-1.fc20

Comment 17 Fedora Update System 2014-02-06 02:12:44 UTC
mock-1.1.36-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.36-1.el6

Comment 18 Fedora Update System 2014-02-08 05:03:27 UTC
mock-1.1.36-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2014-03-25 20:25:40 UTC
mock-1.1.37-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.37-1.fc19

Comment 20 Fedora Update System 2014-03-25 20:28:02 UTC
mock-1.1.37-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.37-1.fc20

Comment 21 Fedora Update System 2014-03-25 20:29:53 UTC
mock-1.1.37-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.37-1.el6

Comment 22 Fedora Update System 2014-03-27 17:48:29 UTC
mock-1.1.37-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.37-2.fc20

Comment 23 Fedora Update System 2014-03-27 17:50:25 UTC
mock-1.1.37-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.37-2.fc19

Comment 24 Fedora Update System 2014-03-27 17:52:19 UTC
mock-1.1.37-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.37-2.el6

Comment 25 Fedora Update System 2014-03-31 19:05:16 UTC
mock-1.1.38-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/mock-1.1.38-1.fc19

Comment 26 Fedora Update System 2014-03-31 19:07:29 UTC
mock-1.1.38-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/mock-1.1.38-1.el6

Comment 27 Fedora Update System 2014-03-31 19:09:24 UTC
mock-1.1.38-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/mock-1.1.38-1.fc20

Comment 28 Fedora Update System 2014-04-09 13:19:36 UTC
mock-1.1.38-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 29 Fedora Update System 2014-04-18 15:38:24 UTC
mock-1.1.38-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 30 Fedora Update System 2014-04-19 09:20:42 UTC
mock-1.1.38-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.